Merge branch 'js/rebase-i-commentchar-fix'
authorJunio C Hamano <gitster@pobox.com>
Wed, 23 Nov 2016 19:23:17 +0000 (11:23 -0800)
committerJunio C Hamano <gitster@pobox.com>
Wed, 23 Nov 2016 19:23:17 +0000 (11:23 -0800)
"git rebase -i" did not work well with core.commentchar
configuration variable for two reasons, both of which have been
fixed.

* js/rebase-i-commentchar-fix:
rebase -i: handle core.commentChar=auto
stripspace: respect repository config
rebase -i: highlight problems with core.commentchar

1  2 
git-rebase--interactive.sh
t/t3404-rebase-interactive.sh
index ca994c5c545cb0394fc5d355ecb6ea2fe5f1f193,c167bc36b38330834f730078d83a2c75845ba73c..41fd374c725de1f42965b829c2bed5c48c92e19c
@@@ -93,8 -93,17 +93,17 @@@ eval 
  GIT_CHERRY_PICK_HELP="$resolvemsg"
  export GIT_CHERRY_PICK_HELP
  
- comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
- : ${comment_char:=#}
+ comment_char=$(git config --get core.commentchar 2>/dev/null)
+ case "$comment_char" in
+ '' | auto)
+       comment_char="#"
+       ;;
+ ?)
+       ;;
+ *)
+       comment_char=$(echo "$comment_char" | cut -c1)
+       ;;
+ esac
  
  warn () {
        printf '%s\n' "$*" >&2
@@@ -121,14 -130,14 +130,14 @@@ mark_action_done () 
        sed -e 1q < "$todo" >> "$done"
        sed -e 1d < "$todo" >> "$todo".new
        mv -f "$todo".new "$todo"
 -      new_count=$(git stripspace --strip-comments <"$done" | wc -l)
 +      new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
        echo $new_count >"$msgnum"
        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
        echo $total >"$end"
        if test "$last_count" != "$new_count"
        then
                last_count=$new_count
 -              printf "Rebasing (%d/%d)\r" $new_count $total
 +              eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
                test -z "$verbose" || echo
        fi
  }
@@@ -144,28 -153,29 +153,28 @@@ reschedule_last_action () 
  }
  
  append_todo_help () {
 -      git stripspace --comment-lines >>"$todo" <<\EOF
 -
 +      gettext "
  Commands:
   p, pick = use commit
   r, reword = use commit, but edit the commit message
   e, edit = use commit, but stop for amending
   s, squash = use commit, but meld into previous commit
 - f, fixup = like "squash", but discard this commit's log message
 + f, fixup = like \"squash\", but discard this commit's log message
   x, exec = run command (the rest of the line) using shell
   d, drop = remove commit
  
  These lines can be re-ordered; they are executed from top to bottom.
 +" | git stripspace --comment-lines >>"$todo"
  
 -EOF
        if test $(get_missing_commit_check_level) = error
        then
 -              git stripspace --comment-lines >>"$todo" <<\EOF
 +              gettext "
  Do not remove any line. Use 'drop' explicitly to remove a commit.
 -EOF
 +" | git stripspace --comment-lines >>"$todo"
        else
 -              git stripspace --comment-lines >>"$todo" <<\EOF
 +              gettext "
  If you remove a line here THAT COMMIT WILL BE LOST.
 -EOF
 +" | git stripspace --comment-lines >>"$todo"
        fi
  }
  
@@@ -191,6 -201,7 +200,6 @@@ make_patch () 
  die_with_patch () {
        echo "$1" > "$state_dir"/stopped-sha
        make_patch "$1"
 -      git rerere
        die "$2"
  }
  
@@@ -199,20 -210,18 +208,20 @@@ exit_with_patch () 
        make_patch $1
        git rev-parse --verify HEAD > "$amend"
        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 -      warn "You can amend the commit now, with"
 -      warn
 -      warn "  git commit --amend $gpg_sign_opt_quoted"
 -      warn
 -      warn "Once you are satisfied with your changes, run"
 -      warn
 -      warn "  git rebase --continue"
 +      warn "$(eval_gettext "\
 +You can amend the commit now, with
 +
 +      git commit --amend \$gpg_sign_opt_quoted
 +
 +Once you are satisfied with your changes, run
 +
 +      git rebase --continue")"
        warn
        exit $2
  }
  
  die_abort () {
 +      apply_autostash
        rm -rf "$state_dir"
        die "$1"
  }
@@@ -222,12 -231,10 +231,12 @@@ has_action () 
  }
  
  is_empty_commit() {
 -      tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
 -              die "$1: not a commit that can be picked")
 -      ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
 -              ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
 +      tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
 +              sha1=$1
 +              die "$(eval_gettext "\$sha1: not a commit that can be picked")"
 +      }
 +      ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
 +              ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
        test "$tree" = "$ptree"
  }
  
@@@ -263,7 -270,7 +272,7 @@@ pick_one () 
  
        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 -      output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
 +      output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
  
        if is_empty_commit "$sha1"
        then
@@@ -305,7 -312,7 +314,7 @@@ pick_one_preserving_merges () 
                                git rev-parse HEAD > "$rewritten"/$current_commit
                        done <"$state_dir"/current-commit
                        rm "$state_dir"/current-commit ||
 -                      die "Cannot write current commit's replacement sha1"
 +                              die "$(gettext "Cannot write current commit's replacement sha1")"
                fi
        fi
  
        done
        case $fast_forward in
        t)
 -              output warn "Fast-forward to $sha1"
 +              output warn "$(eval_gettext "Fast-forward to \$sha1")"
                output git reset --hard $sha1 ||
 -                      die "Cannot fast-forward to $sha1"
 +                      die "$(eval_gettext "Cannot fast-forward to \$sha1")"
                ;;
        f)
                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
                then
                        # detach HEAD to current parent
                        output git checkout $first_parent 2> /dev/null ||
 -                              die "Cannot move HEAD to $first_parent"
 +                              die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
                fi
  
                case "$new_parents" in
                ' '*' '*)
 -                      test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
 +                      test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
  
                        # redo merge
                        author_script_content=$(get_author_ident_from_commit $sha1)
                                $merge_args $strategy_args -m "$msg_content" $new_parents'
                        then
                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 -                              die_with_patch $sha1 "Error redoing merge $sha1"
 +                              die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
                        fi
                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
                        ;;
                        output eval git cherry-pick \
                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
                                "$strategy_args" "$@" ||
 -                              die_with_patch $sha1 "Could not pick $sha1"
 +                              die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
                        ;;
                esac
                ;;
        esac
  }
  
 -nth_string () {
 -      case "$1" in
 -      *1[0-9]|*[04-9]) echo "$1"th;;
 -      *1) echo "$1"st;;
 -      *2) echo "$1"nd;;
 -      *3) echo "$1"rd;;
 -      esac
 +this_nth_commit_message () {
 +      n=$1
 +      eval_gettext "This is the commit message #\${n}:"
 +}
 +
 +skip_nth_commit_message () {
 +      n=$1
 +      eval_gettext "The commit message #\${n} will be skipped:"
  }
  
  update_squash_messages () {
        if test -f "$squash_msg"; then
                mv "$squash_msg" "$squash_msg".bak || exit
                count=$(($(sed -n \
 -                      -e "1s/^. This is a combination of \(.*\) commits\./\1/p" \
 +                      -e "1s/^$comment_char.*\([0-9][0-9]*\).*/\1/p" \
                        -e "q" < "$squash_msg".bak)+1))
                {
 -                      printf '%s\n' "$comment_char This is a combination of $count commits."
 +                      printf '%s\n' "$comment_char $(eval_ngettext \
 +                              "This is a combination of \$count commit." \
 +                              "This is a combination of \$count commits." \
 +                              $count)"
                        sed -e 1d -e '2,/^./{
                                /^$/d
                        }' <"$squash_msg".bak
                } >"$squash_msg"
        else
 -              commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
 +              commit_message HEAD > "$fixup_msg" || die "$(gettext "Cannot write \$fixup_msg")"
                count=2
                {
 -                      printf '%s\n' "$comment_char This is a combination of 2 commits."
 -                      printf '%s\n' "$comment_char The first commit's message is:"
 +                      printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
 +                      printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
                        echo
                        cat "$fixup_msg"
                } >"$squash_msg"
        squash)
                rm -f "$fixup_msg"
                echo
 -              printf '%s\n' "$comment_char This is the $(nth_string $count) commit message:"
 +              printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
                echo
                commit_message $2
                ;;
        fixup)
                echo
 -              printf '%s\n' "$comment_char The $(nth_string $count) commit message will be skipped:"
 +              printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
                echo
                # Change the space after the comment character to TAB:
                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
@@@ -466,14 -469,12 +475,14 @@@ peek_next_command () 
  # messages, effectively causing the combined commit to be used as the
  # new basis for any further squash/fixups.  Args: sha1 rest
  die_failed_squash() {
 +      sha1=$1
 +      rest=$2
        mv "$squash_msg" "$msg" || exit
        rm -f "$fixup_msg"
        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
        warn
 -      warn "Could not apply $1... $2"
 -      die_with_patch $1 ""
 +      warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
 +      die_with_patch $sha1 ""
  }
  
  flush_rewritten_pending() {
@@@ -497,8 -498,6 +506,8 @@@ record_in_rewritten() 
  }
  
  do_pick () {
 +      sha1=$1
 +      rest=$2
        if test "$(git rev-parse HEAD)" = "$squash_onto"
        then
                # Set the correct commit message and author info on the
                # resolve before manually running git commit --amend then git
                # rebase --continue.
                git commit --allow-empty --allow-empty-message --amend \
 -                         --no-post-rewrite -n -q -C $1 &&
 -                      pick_one -n $1 &&
 +                         --no-post-rewrite -n -q -C $sha1 &&
 +                      pick_one -n $sha1 &&
                        git commit --allow-empty --allow-empty-message \
 -                                 --amend --no-post-rewrite -n -q -C $1 \
 +                                 --amend --no-post-rewrite -n -q -C $sha1 \
                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 -                      die_with_patch $1 "Could not apply $1... $2"
 +                                 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
        else
 -              pick_one $1 ||
 -                      die_with_patch $1 "Could not apply $1... $2"
 +              pick_one $sha1 ||
 +                      die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
        fi
  }
  
@@@ -546,11 -545,10 +555,11 @@@ do_next () 
                mark_action_done
                do_pick $sha1 "$rest"
                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
 -                      warn "Could not amend commit after successfully picking $sha1... $rest"
 -                      warn "This is most likely due to an empty commit message, or the pre-commit hook"
 -                      warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
 -                      warn "you are able to reword the commit."
 +                      warn "$(eval_gettext "\
 +Could not amend commit after successfully picking \$sha1... \$rest
 +This is most likely due to an empty commit message, or the pre-commit hook
 +failed. If the pre-commit hook failed, you may need to resolve the issue before
 +you are able to reword the commit.")"
                        exit_with_patch $sha1 1
                }
                record_in_rewritten $sha1
  
                mark_action_done
                do_pick $sha1 "$rest"
 -              warn "Stopped at $sha1... $rest"
 +              sha1_abbrev=$(git rev-parse --short $sha1)
 +              warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
                exit_with_patch $sha1 0
                ;;
        squash|s|fixup|f)
                comment_for_reflog $squash_style
  
                test -f "$done" && has_action "$done" ||
 -                      die "Cannot '$squash_style' without a previous commit"
 +                      die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
  
                mark_action_done
                update_squash_messages $squash_style $sha1
        x|"exec")
                read -r command rest < "$todo"
                mark_action_done
 -              printf 'Executing: %s\n' "$rest"
 +              eval_gettextln "Executing: \$rest"
                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
                status=$?
                # Run in subshell because require_clean_work_tree can die.
                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
                if test "$status" -ne 0
                then
 -                      warn "Execution failed: $rest"
 +                      warn "$(eval_gettext "Execution failed: \$rest")"
                        test "$dirty" = f ||
 -                      warn "and made changes to the index and/or the working tree"
 +                              warn "$(gettext "and made changes to the index and/or the working tree")"
  
 -                      warn "You can fix the problem, and then run"
 -                      warn
 -                      warn "  git rebase --continue"
 +                      warn "$(gettext "\
 +You can fix the problem, and then run
 +
 +      git rebase --continue")"
                        warn
                        if test $status -eq 127         # command not found
                        then
                        exit "$status"
                elif test "$dirty" = t
                then
 -                      warn "Execution succeeded: $rest"
 -                      warn "but left changes to the index and/or the working tree"
 -                      warn "Commit or stash your changes, and then run"
 -                      warn
 -                      warn "  git rebase --continue"
 +                      # TRANSLATORS: after these lines is a command to be issued by the user
 +                      warn "$(eval_gettext "\
 +Execution succeeded: \$rest
 +but left changes to the index and/or the working tree
 +Commit or stash your changes, and then run
 +
 +      git rebase --continue")"
                        warn
                        exit 1
                fi
                ;;
        *)
 -              warn "Unknown command: $command $sha1 $rest"
 -              fixtodo="Please fix this using 'git rebase --edit-todo'."
 +              warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
 +              fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
                if git rev-parse --verify -q "$sha1" >/dev/null
                then
                        die_with_patch $sha1 "$fixtodo"
                "$hook" rebase < "$rewritten_list"
                true # we don't care if this hook failed
        fi &&
 -      warn "Successfully rebased and updated $head_name."
 +              warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
  
        return 1 # not failure; just to break the do_rest loop
  }
@@@ -737,7 -731,7 +746,7 @@@ skip_unnecessary_picks () 
                record_in_rewritten "$onto"
                ;;
        esac ||
 -      die "Could not skip unnecessary pick commands"
 +              die "$(gettext "Could not skip unnecessary pick commands")"
  }
  
  transform_todo_ids () {
@@@ -881,12 -875,12 +890,12 @@@ add_exec_commands () 
  # $3: the input filename
  check_commit_sha () {
        badsha=0
 -      if test -z $1
 +      if test -z "$1"
        then
                badsha=1
        else
                sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
 -              if test -z $sha1_verif
 +              if test -z "$sha1_verif"
                then
                        badsha=1
                fi
        if test $badsha -ne 0
        then
                line="$(sed -n -e "${2}p" "$3")"
 -              warn "Warning: the SHA-1 is missing or isn't" \
 -                      "a commit in the following line:"
 -              warn " - $line"
 +              warn "$(eval_gettext "\
 +Warning: the SHA-1 is missing or isn't a commit in the following line:
 + - \$line")"
                warn
        fi
  
@@@ -928,9 -922,9 +937,9 @@@ check_bad_cmd_and_sha () 
                        ;;
                *)
                        line="$(sed -n -e "${lineno}p" "$1")"
 -                      warn "Warning: the command isn't recognized" \
 -                              "in the following line:"
 -                      warn " - $line"
 +                      warn "$(eval_gettext "\
 +Warning: the command isn't recognized in the following line:
 + - \$line")"
                        warn
                        retval=1
                        ;;
@@@ -967,7 -961,7 +976,7 @@@ warn_lines () 
  # Switch to the branch in $into and notify it in the reflog
  checkout_onto () {
        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
 -      output git checkout $onto || die_abort "could not detach HEAD"
 +      output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
        git update-ref ORIG_HEAD $orig_head
  }
  
@@@ -1005,26 -999,28 +1014,26 @@@ check_todo_list () 
                then
                        test "$check_level" = error && raise_error=t
  
 -                      warn "Warning: some commits may have been dropped" \
 -                              "accidentally."
 -                      warn "Dropped commits (newer to older):"
 +                      warn "$(gettext "\
 +Warning: some commits may have been dropped accidentally.
 +Dropped commits (newer to older):")"
  
                        # Make the list user-friendly and display
                        opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
                        git rev-list $opt <"$todo".miss | warn_lines
  
 -                      warn "To avoid this message, use \"drop\" to" \
 -                              "explicitly remove a commit."
 -                      warn
 -                      warn "Use 'git config rebase.missingCommitsCheck' to change" \
 -                              "the level of warnings."
 -                      warn "The possible behaviours are: ignore, warn, error."
 +                      warn "$(gettext "\
 +To avoid this message, use \"drop\" to explicitly remove a commit.
 +
 +Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
 +The possible behaviours are: ignore, warn, error.")"
                        warn
                fi
                ;;
        ignore)
                ;;
        *)
 -              warn "Unrecognized setting $check_level for option" \
 -                      "rebase.missingCommitsCheck. Ignoring."
 +              warn "$(eval_gettext "Unrecognized setting \$check_level for option rebase.missingCommitsCheck. Ignoring.")"
                ;;
        esac
  
                # placed before the commit of the next action
                checkout_onto
  
 -              warn "You can fix this with 'git rebase --edit-todo'."
 -              die "Or you can abort the rebase with 'git rebase --abort'."
 +              warn "$(gettext "You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.")"
 +              die "$(gettext "Or you can abort the rebase with 'git rebase --abort'.")"
        fi
  }
  
  # below were not inside any function, and expected to return
  # to the function that dot-sourced us.
  #
 -# However, FreeBSD /bin/sh misbehaves on such a construct and
 -# continues to run the statements that follow such a "return".
 +# However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
 +# construct and continue to run the statements that follow such a "return".
  # As a work-around, we introduce an extra layer of a function
  # here, and immediately call it after defining it.
  git_rebase__interactive () {
@@@ -1066,43 -1062,41 +1075,43 @@@ continue
  
                test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
                rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
 -              die "Could not remove CHERRY_PICK_HEAD"
 +              die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
        else
                if ! test -f "$author_script"
                then
                        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 -                      die "You have staged changes in your working tree. If these changes are meant to be
 +                      die "$(eval_gettext "\
 +You have staged changes in your working tree.
 +If these changes are meant to be
  squashed into the previous commit, run:
  
 -  git commit --amend $gpg_sign_opt_quoted
 +  git commit --amend \$gpg_sign_opt_quoted
  
  If they are meant to go into a new commit, run:
  
 -  git commit $gpg_sign_opt_quoted
 +  git commit \$gpg_sign_opt_quoted
  
 -In both case, once you're done, continue with:
 +In both cases, once you're done, continue with:
  
    git rebase --continue
 -"
 +")"
                fi
                . "$author_script" ||
 -                      die "Error trying to find the author identity to amend commit"
 +                      die "$(gettext "Error trying to find the author identity to amend commit")"
                if test -f "$amend"
                then
                        current_head=$(git rev-parse --verify HEAD)
                        test "$current_head" = $(cat "$amend") ||
 -                      die "\
 -You have uncommitted changes in your working tree. Please, commit them
 -first and then run 'git rebase --continue' again."
 +                      die "$(gettext "\
 +You have uncommitted changes in your working tree. Please commit them
 +first and then run 'git rebase --continue' again.")"
                        do_with_author git commit --amend --no-verify -F "$msg" -e \
                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 -                              die "Could not commit staged changes."
 +                              die "$(gettext "Could not commit staged changes.")"
                else
                        do_with_author git commit --no-verify -F "$msg" -e \
                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 -                              die "Could not commit staged changes."
 +                              die "$(gettext "Could not commit staged changes.")"
                fi
        fi
  
@@@ -1126,36 -1120,40 +1135,36 @@@ edit-todo
        mv -f "$todo".new "$todo"
        collapse_todo_ids
        append_todo_help
 -      git stripspace --comment-lines >>"$todo" <<\EOF
 -
 +      gettext "
  You are editing the todo file of an ongoing interactive rebase.
  To continue rebase after editing, run:
      git rebase --continue
  
 -EOF
 +" | git stripspace --comment-lines >>"$todo"
  
        git_sequence_editor "$todo" ||
 -              die "Could not execute editor"
 +              die "$(gettext "Could not execute editor")"
        expand_todo_ids
  
        exit
        ;;
  esac
  
 -git var GIT_COMMITTER_IDENT >/dev/null ||
 -      die "You need to set your committer info first"
 -
  comment_for_reflog start
  
  if test ! -z "$switch_to"
  then
        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
        output git checkout "$switch_to" -- ||
 -      die "Could not checkout $switch_to"
 +              die "$(eval_gettext "Could not checkout \$switch_to")"
  
        comment_for_reflog start
  fi
  
 -orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
 -mkdir -p "$state_dir" || die "Could not create temporary $state_dir"
 +orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
 +mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
  
 -: > "$state_dir"/interactive || die "Could not mark as interactive"
 +: > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
  write_basic_state
  if test t = "$preserve_merges"
  then
                for c in $(git merge-base --all $orig_head $upstream)
                do
                        echo $onto > "$rewritten"/$c ||
 -                              die "Could not init rewritten commits"
 +                              die "$(gettext "Could not init rewritten commits")"
                done
        else
                mkdir "$rewritten" &&
                echo $onto > "$rewritten"/root ||
 -                      die "Could not init rewritten commits"
 +                      die "$(gettext "Could not init rewritten commits")"
        fi
        # No cherry-pick because our first pass is to determine
        # parents to rewrite and skipping dropped commits would
@@@ -1269,20 -1267,18 +1278,20 @@@ todocount=${todocount##* 
  
  cat >>"$todo" <<EOF
  
 -$comment_char Rebase $shortrevisions onto $shortonto ($todocount command(s))
 +$comment_char $(eval_ngettext \
 +      "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
 +      "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
 +      "$todocount")
  EOF
  append_todo_help
 -git stripspace --comment-lines >>"$todo" <<\EOF
 -
 +gettext "
  However, if you remove everything, the rebase will be aborted.
  
 -EOF
 +" | git stripspace --comment-lines >>"$todo"
  
  if test -z "$keep_empty"
  then
 -      printf '%s\n' "$comment_char Note that empty commits are commented out" >>"$todo"
 +      printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
  fi
  
  
@@@ -1292,7 -1288,7 +1301,7 @@@ has_action "$todo" |
  cp "$todo" "$todo".backup
  collapse_todo_ids
  git_sequence_editor "$todo" ||
 -      die_abort "Could not execute editor"
 +      die_abort "$(gettext "Could not execute editor")"
  
  has_action "$todo" ||
        return 2
index e38e2963880d42dc335870292f7a2aa4d583497c,5d0a7dca9d18a05ccfaa64f4cfaa406cea9559d9..c896a4c1067fc80378130a09705bef58370f01be
@@@ -60,9 -60,9 +60,9 @@@ test_expect_success 'setup' 
        test_commit P fileP
  '
  
 -# "exec" commands are ran with the user shell by default, but this may
 +# "exec" commands are run with the user shell by default, but this may
  # be non-POSIX. For example, if SHELL=zsh then ">file" doesn't work
 -# to create a file. Unseting SHELL avoids such non-portable behavior
 +# to create a file. Unsetting SHELL avoids such non-portable behavior
  # in tests. It must be exported for it to take effect where needed.
  SHELL=
  export SHELL
@@@ -219,9 -219,9 +219,9 @@@ test_expect_success 'abort with error w
        git commit -m "remove file in base" &&
        set_fake_editor &&
        test_must_fail git rebase -i master > output 2>&1 &&
 -      grep "The following untracked working tree files would be overwritten by checkout:" \
 +      test_i18ngrep "The following untracked working tree files would be overwritten by checkout:" \
                output &&
 -      grep "file1" output &&
 +      test_i18ngrep "file1" output &&
        test_path_is_missing .git/rebase-merge &&
        git reset --hard HEAD^
  '
@@@ -540,7 -540,7 +540,7 @@@ test_expect_success 'clean error after 
        echo "edited again" > file7 &&
        git add file7 &&
        test_must_fail git rebase --continue 2>error &&
 -      grep "You have staged changes in your working tree." error
 +      test_i18ngrep "You have staged changes in your working tree." error
  '
  
  test_expect_success 'rebase a detached HEAD' '
@@@ -770,6 -770,7 +770,6 @@@ test_expect_success 'rebase-i history w
        test_cmp expect actual
  '
  
 -
  test_expect_success 'prepare for rebase -i --exec' '
        git checkout master &&
        git checkout -b execute &&
        test_commit three_exec main.txt three_exec
  '
  
 -
  test_expect_success 'running "git rebase -i --exec git show HEAD"' '
        set_fake_editor &&
        git rebase -i --exec "git show HEAD" HEAD~2 >actual &&
        test_cmp expected actual
  '
  
 -
  test_expect_success 'running "git rebase --exec git show HEAD -i"' '
        git reset --hard execute &&
        set_fake_editor &&
        test_cmp expected actual
  '
  
 -
  test_expect_success 'running "git rebase -ix git show HEAD"' '
        git reset --hard execute &&
        set_fake_editor &&
@@@ -830,6 -834,7 +830,6 @@@ test_expect_success 'rebase -ix with se
        test_cmp expected actual
  '
  
 -
  test_expect_success 'rebase -ix with several instances of --exec' '
        git reset --hard execute &&
        set_fake_editor &&
        test_cmp expected actual
  '
  
 -
  test_expect_success 'rebase -ix with --autosquash' '
        git reset --hard execute &&
        git checkout -b autosquash &&
        test_cmp expected actual
  '
  
 -
 -test_expect_success 'rebase --exec without -i shows error message' '
 +test_expect_success 'rebase --exec works without -i ' '
        git reset --hard execute &&
 -      set_fake_editor &&
 -      test_must_fail git rebase --exec "git show HEAD" HEAD~2 2>actual &&
 -      echo "The --exec option must be used with the --interactive option" >expected &&
 -      test_i18ncmp expected actual
 +      rm -rf exec_output &&
 +      EDITOR="echo >invoked_editor" git rebase --exec "echo a line >>exec_output"  HEAD~2 2>actual &&
 +      test_i18ngrep  "Successfully rebased and updated" actual &&
 +      test_line_count = 2 exec_output &&
 +      test_path_is_missing invoked_editor
  '
  
 -
  test_expect_success 'rebase -i --exec without <CMD>' '
        git reset --hard execute &&
        set_fake_editor &&
@@@ -976,6 -983,17 +976,17 @@@ test_expect_success 'rebase -i respect
        test B = $(git cat-file commit HEAD^ | sed -ne \$p)
  '
  
+ test_expect_success 'rebase -i respects core.commentchar=auto' '
+       test_config core.commentchar auto &&
+       write_script copy-edit-script.sh <<-\EOF &&
+       cp "$1" edit-script
+       EOF
+       test_set_editor "$(pwd)/copy-edit-script.sh" &&
+       test_when_finished "git rebase --abort || :" &&
+       git rebase -i HEAD^ &&
+       test -z "$(grep -ve "^#" -e "^\$" -e "^pick" edit-script)"
+ '
  test_expect_success 'rebase -i, with <onto> and <upstream> specified as :/quuxery' '
        test_when_finished "git branch -D torebase" &&
        git checkout -b torebase branch1 &&
@@@ -1060,7 -1078,7 +1071,7 @@@ test_expect_success 'todo count' 
        EOF
        test_set_editor "$(pwd)/dump-raw.sh" &&
        git rebase -i HEAD~4 >actual &&
 -      grep "^# Rebase ..* onto ..* ([0-9]" actual
 +      test_i18ngrep "^# Rebase ..* onto ..* ([0-9]" actual
  '
  
  test_expect_success 'rebase -i commits that overwrite untracked files (pick)' '
@@@ -1160,7 -1178,7 +1171,7 @@@ test_expect_success 'rebase -i respect
        FAKE_LINES="1 2 3 4" \
                git rebase -i --root 2>actual &&
        test D = $(git cat-file commit HEAD | sed -ne \$p) &&
 -      test_cmp expect actual
 +      test_i18ncmp expect actual
  '
  
  cat >expect <<EOF
@@@ -1181,7 -1199,7 +1192,7 @@@ test_expect_success 'rebase -i respect
        set_fake_editor &&
        FAKE_LINES="1 2 3 4" \
                git rebase -i --root 2>actual &&
 -      test_cmp expect actual &&
 +      test_i18ncmp expect actual &&
        test D = $(git cat-file commit HEAD | sed -ne \$p)
  '
  
@@@ -1195,7 -1213,7 +1206,7 @@@ To avoid this message, use "drop" to ex
  Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
  The possible behaviours are: ignore, warn, error.
  
 -You can fix this with 'git rebase --edit-todo'.
 +You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.
  Or you can abort the rebase with 'git rebase --abort'.
  EOF
  
@@@ -1205,7 -1223,7 +1216,7 @@@ test_expect_success 'rebase -i respect
        set_fake_editor &&
        test_must_fail env FAKE_LINES="1 2 4" \
                git rebase -i --root 2>actual &&
 -      test_cmp expect actual &&
 +      test_i18ncmp expect actual &&
        cp .git/rebase-merge/git-rebase-todo.backup \
                .git/rebase-merge/git-rebase-todo &&
        FAKE_LINES="1 2 drop 3 4 drop 5" \
@@@ -1219,7 -1237,7 +1230,7 @@@ cat >expect <<EO
  Warning: the command isn't recognized in the following line:
   - badcmd $(git rev-list --oneline -1 master~1)
  
 -You can fix this with 'git rebase --edit-todo'.
 +You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.
  Or you can abort the rebase with 'git rebase --abort'.
  EOF
  
@@@ -1228,7 -1246,7 +1239,7 @@@ test_expect_success 'static check of ba
        set_fake_editor &&
        test_must_fail env FAKE_LINES="1 2 3 bad 4 5" \
                git rebase -i --root 2>actual &&
 -      test_cmp expect actual &&
 +      test_i18ncmp expect actual &&
        FAKE_LINES="1 2 3 drop 4 5" git rebase --edit-todo &&
        git rebase --continue &&
        test E = $(git cat-file commit HEAD | sed -ne \$p) &&
@@@ -1254,7 -1272,7 +1265,7 @@@ cat >expect <<EO
  Warning: the SHA-1 is missing or isn't a commit in the following line:
   - edit XXXXXXX False commit
  
 -You can fix this with 'git rebase --edit-todo'.
 +You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.
  Or you can abort the rebase with 'git rebase --abort'.
  EOF
  
@@@ -1263,7 -1281,7 +1274,7 @@@ test_expect_success 'static check of ba
        set_fake_editor &&
        test_must_fail env FAKE_LINES="1 2 edit fakesha 3 4 5 #" \
                git rebase -i --root 2>actual &&
 -      test_cmp expect actual &&
 +      test_i18ncmp expect actual &&
        FAKE_LINES="1 2 4 5 6" git rebase --edit-todo &&
        git rebase --continue &&
        test E = $(git cat-file commit HEAD | sed -ne \$p)
@@@ -1281,12 -1299,4 +1292,12 @@@ test_expect_success 'editor saves as CR
        )
  '
  
 +SQ="'"
 +test_expect_success 'rebase -i --gpg-sign=<key-id>' '
 +      set_fake_editor &&
 +      FAKE_LINES="edit 1" git rebase -i --gpg-sign="\"S I Gner\"" HEAD^ \
 +              >out 2>err &&
 +      test_i18ngrep "$SQ-S\"S I Gner\"$SQ" err
 +'
 +
  test_done